%
% $Id: swrl_xml.pl,v 1.0 2009-05-26 14:51:12 mikel Exp $
%
% Copyright 2007,8 by Grzegorz J. Nalepa
%
% VARDA XML support
%
%
%     Copyright (C) 2006-9 by the HeKatE Project
%
%     VARDA has been develped by the HeKatE Project, 
%     see http://hekate.ia.agh.edu.pl
%
%     This file is part of VARDA.
%
%     VARDA is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
%
%     VARDA is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
%
%     You should have received a copy of the GNU General Public License
%     along with VARDA.  If not, see <http://www.gnu.org/licenses/>.
%

:- ensure_loaded('heart.pl').
%:- ensure_loaded('therm-rt.pl').


:- write('SWRLtrans: $Id: swrl_xml.pl,v 1.0 2009-05-26 14:51:12 mikel Exp $'),nl.

% SWRL XML handling
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
:- use_module(library(lists)).

swrl_xml_gen(F) :-
	tell(F),
	swrl_xml_gen,
	told.

swrl_xml_gen :-

	xml_indent_mark_set('swrl'),
	xml_indent_clear('swrl'),
	swrl_xml_head,

	swrl_xml_var_gen,
	swrl_xml_rulset_gen,
	swrl_xml_tail,
	!.

swrl_xml_head :-
	write('<?xml version="1.0" ?>'), nl,
	write('<!DOCTYPE swrlx:Ontology ['), nl,
	write('<!ENTITY swrlb "http://www.w3.org/2003/11/swrlb">'), nl,
	write('<!ENTITY xsd "http://www.w3.org/2001/XMLSchema">'), nl,
	write('<!ENTITY map "http://www.daml.org/2001/06/map/map-ont#">'), nl,
	write(']>'), nl,
	nl,
	write('<swrlx:Ontology'), nl,
	write('	xmlns:owlx="http://www.w3.org/2003/05/owl-xml"'), nl,
	write('	xmlns:swrlx="http://www.w3.org/2003/11/swrlx"'), nl,
	write('	xmlns:ruleml="http://www.w3.org/2003/11/ruleml"'), nl,
	write('	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'), nl,
	write('	xsi:schemaLocation="http://www.w3.org/2003/11/swrlx http://www.ruleml.org/swrl/xsd/swrlx.xsd"'), nl,
	write('	>'), nl,
	xml_indent_more('swrl'),
	write('<owlx:Annotation>'), nl,
	xml_indent_more('swrl'),
		write('<owlx:Documentation> XTT to SWRL Translator</owlx:Documentation>'), nl,
	xml_indent_less('swrl'),
	write('</owlx:Annotation>'), nl,
	write('<owlx:VersionInfo>v 1.0 2009/05/26 Michal Lesiak mikelik@o2.pl</owlx:VersionInfo>'), nl,
	nl.
	%TODO obsluga sztucznych polaczen w SWRL dla tabel regulowych
	%write('<owlx:ObjectProperty owlx:name="table"/>'), nl,
	%write('<owlx:ObjectProperty owlx:name="link"/>'), nl.

swrl_xml_tail :-
	write('</swrlx:Ontology>'),
	nl, nl,
	xml_indent_less('swrl').

swrl_xml_var_gen :-
    xattr(T),
	member(name:Name,T),
	swrl_xml_var_gen2(Name),
	nl.
swrl_xml_var_gen2(Name) :-
	xml_tag_open_indent('ruleml:var',_),
	write(Name),
	xml_tag_close_noindent('ruleml:var').

swrl_xml_rulset_gen :- %(Snames, Santecs, Sconseqs) %debug
	xrule(Name:Antec==>Consdirty),
	swrl_xml_rulset_gen2(Name,Antec,Consdirty),
	fail.
swrl_xml_rulset_gen.

swrl_xml_rulset_gen2(Name,Antec,Consdirty) :- 
	swrl_xml_conseq_clean(Consdirty,Conseq),
%ms/1:[month in [january, february, december]] ==> [season set summer]
%% X = (th/4:[today eq workday, hour in [9 to 17]]==>[operation set during_bizhours]) ;
%%% Antec = [today eq workday, month in [january, february, december]]

	swrl_xml_rul_split(Antec,Antecout),
%%% Antecout =[[today eq workday], [month in january, month in february, month in december]]

	cross_product(Antecout, Antecross),
%%% Antecross = [[today eq workday,month in january], [today eq workday,month in february], [today eq workday, month in december]]

	swrl_xml_rul_create(Name/0,Antecross,Conseq,Names,Antecs,Conseqs),
%Names = [ms/1/1, ms/1/2, ms1/1/3]
%Antecs = [[month in january], [month in february], [month in december]]
%Conseqs = [ season set summer, season set summer, season set summer]
%%Antecs = [[today eq workday,hour > 9, hour < 17]]
%%%Antecs = [[today eq workday, month in january], [today eq workday,month in february], [today eq workday,month in december]]

	swrl_xml_rulset_trans(Names, Antecs, Conseqs, Snames, Santecs, Sconseqs),
	swrl_xml_rulset_out(Snames,Santecs,Sconseqs).

%odetnij :DestTableId/DestRuleId czyli rule2table link
% oraz odetnij **> co to by nie bylo ;)
swrl_xml_conseq_clean(Conseq:_,Conseq).
swrl_xml_conseq_clean(Conseq**>_,Conseq).
swrl_xml_conseq_clean([Conseq],[Conseq]).
	%\+ compound(Conseq).

swrl_xml_rul_split([],[]).
swrl_xml_rul_split([Antec|Antecs],[Ahead|Antecsout]) :-
	swrl_xml_rul_merge(Antec, Ahead), %Merged to lista, nawet gdy Antec nia nie byla
%%% [today eq workday, month in [january, february, december]]
% Ahead = [today eq workday]
% Ahead = [month in january, month in february, month in december]
%Antecsout jest do crossa
	%cross_product(union(Merged,),Cartesian), %cross w wyzszej funkcji?
	swrl_xml_rul_split(Antecs,Antecsout).

%stworz tyle regul, ile jest poprzednikow
%przy okazji zrob translacje podstawowa
swrl_xml_rul_create(_,[],_,[],[],[]).
swrl_xml_rul_create(Name/Num/Level,[Antec|Antecrest],Conseq,[Name/Num/Newlevel|Names],[Antec|Antecs],[Conseq|Conseqs]) :-
	Newlevel is Level + 1,
	swrl_xml_rul_create(Name/Num/Newlevel, Antecrest,Conseq,Names,Antecs,Conseqs).

swrl_xml_rulset_trans([],[],[],[],[],[]).
swrl_xml_rulset_trans([Name|Names], [Antec|Antecs], [Conseq|Conseqs], [Name|Snames], [Santec|Santecs], [Sconseq|Sconseqs]) :-
	swrl_xml_rul_trans(Antec,Santec),%translacja poprzednika
	swrl_xml_rul_trans(Conseq,Sconseq),%translacja nastepnika
	swrl_xml_rulset_trans(Names, Antecs, Conseqs, Snames, Santecs, Sconseqs).


%operator --> [equal].
%operator --> [greaterThan].
%operator --> [lessThan].
%operator --> [greaterThanOrEqual].
%operator --> [lessThanOrEqual].

xtt_swrl(eq,equal).
xtt_swrl(in, equal).
xtt_swrl(set, equal).
xtt_swrl(gt,greaterThan).
xtt_swrl(lt,lessThan).
xtt_swrl(gte,greaterThanOrEqual).
xtt_swrl(lte,lessThanOrEqual).

%obsluga swrl_xml_rul_trans([today eq weekend, hour eq any],X).
swrl_xml_rul_trans([],[]).
swrl_xml_rul_trans([Xtt|Xrest], [Swrl|Srest]) :-
	arg(2,Xtt,Second),
	\+ compound(Second),
	functor(Xtt,Xfun,2),
	xtt_swrl(Xfun,Sfun),
	functor(Swrl,Sfun,2),
	arg(1,Xtt,First), arg(1,Swrl,First),
	arg(2,Xtt,Second), arg(2,Swrl,Second),
	swrl_xml_rul_trans(Xrest,Srest).

%obsluga Xtt =[ X in (1 to 2)] zamienia na [Swrl,Srwl2]= [X gte 1, X lte 2]
swrl_xml_rul_trans([Xtt], [Swrl,Swrl2]) :-
	arg(2,Xtt,Second),
	compound(Second),
	functor(Xtt,in,2), xtt_swrl(gte,SwrlOp1), xtt_swrl(lte,SwrlOp2),
	functor(Swrl,SwrlOp1,2), functor(Swrl2, SwrlOp2, 2),
%xtt_swrl(Operator,Sfun),
	arg(1,Xtt,First), arg(1,Swrl,First), arg(1,Swrl2,First),
	functor(Second,to,2),
	arg(1,Second,SecFirst), arg(2,Swrl,SecFirst),
	arg(2,Second,SecSecond), arg(2,Swrl2, SecSecond).

%swrl_xml_rul_merge(month in [january, february, december], Out).
%Out = [month in january, month in february, month in december] .
swrl_xml_rul_merge(_ in [],[]).
swrl_xml_rul_merge(X in [A|Rest],[X in A|Merged]) :-
	swrl_xml_rul_merge(X in Rest, Merged).
	
swrl_xml_rul_merge(X eq Y, [X eq Y]).	

swrl_xml_rulset_out([], [], []).
swrl_xml_rulset_out([Name|Names],[Antec|Antecs],[Conseq|Conseqs]) :-
	swrl_xml_rul_gen(Name,Antec,Conseq),
	swrl_xml_rulset_out(Names,Antecs,Conseqs).
	

swrl_xml_rul_gen(Name, Antec, Conseq) :-
	xml_tag_open_indent('ruleml:imp',_),nl,
	xml_indent_more('swrl'),
	A/B/C = Name,
	concat_atom([A,B,C],'/',RuleNameTemp), concat_atom(['#',RuleNameTemp],RuleName),
	xml_tag_single_indent('ruleml:_rlab',[['ruleml:href',RuleName]]),
	
	xml_tag_open_indent('ruleml:_body',_),nl,
	xml_indent_more('swrl'),
	
	swrl_xml_rul_gen_body(Antec),

	xml_indent_less('swrl'),
	xml_tag_close_indent('ruleml:_body'),

	xml_tag_open_indent('ruleml:_head',_),nl,
	xml_indent_more('swrl'),
	
	swrl_xml_rul_gen_head(Conseq),

	xml_indent_less('swrl'),
	xml_tag_close_indent('ruleml:_head'),
	xml_indent_less('swrl'),
	xml_tag_close_indent('ruleml:imp').

%TODO predykaty n-arne mozliwe przy Operator = add
swrl_xml_rul_gen_body([]).
swrl_xml_rul_gen_body([Antec|Antecs]) :-
	functor(Antec,Operator,2),
	concat_atom(['&swrlb;#', Operator], SwrlOperator),
	xml_tag_open_indent('swrlx:builtinAtom',[['swrlx:builtin',SwrlOperator]]),nl,
	xml_indent_more('swrl'),

	arg(1,Antec,First),
	swrl_xml_rul_gen_body_built(First),

	arg(2,Antec,Second),
	swrl_xml_rul_gen_body_built(Second),

	xml_indent_less('swrl'),
	xml_tag_close_indent('swrlx:builtinAtom'),
	swrl_xml_rul_gen_body(Antecs).

%variable
swrl_xml_rul_gen_body_built(Att) :-
	ismember(Att),
	xml_tag_open_indent('ruleml:var',_),
	write(Att),
	xml_tag_close_noindent('ruleml:var').

%string,integer
swrl_xml_rul_gen_body_built(Att) :-
	\+ ismember(Att),
	swrl_xml_type(Att,Operator),
	concat_atom(['&xsd;#', Operator], SwrlOperator),
	xml_tag_open_indent('owlx:DataValue',[['owlx:datatype',SwrlOperator]]),
	write(Att),
	xml_tag_close_noindent('owlx:DataValue').

ismember(Att) :-
	xattr(T),member(name:Att,T), !.

swrl_xml_type(Att,Operator) :-
	number(Att),
	Operator = int.

swrl_xml_type(Att,Operator) :-
	\+ number(Att),
	Operator = string.

%TODO merge with _body? tylko wtedy, gdy okaze sie, ze w XTT nie bedzie mozna robic np: att_0 in (1 to 9) or (10 to 11)
swrl_xml_rul_gen_head([]).
swrl_xml_rul_gen_head([Conseq|Conseqs]) :-
	functor(Conseq,Operator,2),
	concat_atom(['&swrlb;#', Operator], SwrlOperator),
	xml_tag_open_indent('swrlx:builtinAtom',[['swrlx:builtin',SwrlOperator]]),nl,
	xml_indent_more('swrl'),
	
	arg(1,Conseq,First),
	swrl_xml_rul_gen_body_built(First),

	arg(2,Conseq,Second),
	swrl_xml_rul_gen_body_built(Second),

	xml_indent_less('swrl'),
	xml_tag_close_indent('swrlx:builtinAtom'),
	swrl_xml_rul_gen_head(Conseqs).


% cross_product([[1,2],[3]],X).
%X = [[1, 3], [2, 3]]
cross_product([], [[]]).
cross_product([L1|Ls], Lds) :-
        cross_product(Ls, Lda),
        add_each_elem(L1, Lda, Lds).

add_each_elem([], _, []).
add_each_elem([X|Xs], Lda, Lds) :-
        add_elem(Lda, X, Lds, Lds_),
        add_each_elem(Xs, Lda, Lds_).

add_elem([], _X, Lds, Lds).
add_elem([L|Ls], X, [[X|L]|XLs], Lds_) :-
        add_elem(Ls, X, XLs, Lds_).

% General XML handling
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

xml_tag_single(Tag,Atts,Out) :-
	var(Atts),
	concat_atom(['<',Tag,'>'],Out).
xml_tag_single(Tag,Atts,Out) :-
	xml_atts_process(Atts,AttsProc),
	concat_atom(['<',Tag,AttsProc,'/>'],Out).
xml_tag_open(Tag,Atts,Out) :-
	var(Atts),
	concat_atom(['<',Tag,'>'],Out).
xml_tag_open(Tag,Atts,Out) :-
	xml_atts_process(Atts,AttsProc),
	concat_atom(['<',Tag,AttsProc,'>'],Out).
xml_tag_close(Tag,Out) :-
	concat_atom(['</',Tag,'>'],Out).

xml_tag_open_indent(Tag,Atts) :-
	xml_indent_current(CI),
	xml_indent(CI,L),
	xml_tag_open(Tag,Atts,To),!, %%% bug work-around
	concat(L,To,TagOpen),
	write(TagOpen).

xml_tag_single_indent(Tag,Atts) :-
	xml_indent_current(CI),
	xml_indent(CI,L),
	xml_tag_single(Tag,Atts,To),
	concat(L,To,TagOpen),
	write(TagOpen),
	nl.

xml_tag_close_indent(Tag) :-
	xml_indent_current(CI),
	xml_indent(CI,L),
	xml_tag_close(Tag,To),
	concat(L,To,TagOpen),
	write(TagOpen),
	nl.

xml_tag_close_noindent(Tag) :-
	xml_tag_close(Tag,To),
	write(To),
	nl.

xml_content(C) :-
	xml_indent_current(CI),
	xml_indent(CI,L),
	concat(L,C,TagOpen),
	write(TagOpen),
	nl.

% list of pairs, name,value
xml_atts_process([],'').
xml_atts_process([A1|A],P) :-
	A1=[N,V],
	xml_att_build(N,V,P1),
	xml_atts_process(A,P2),
	concat(P1,P2,P).
xml_att_build(N,V,P) :-
	concat_atom([' ',N,'=','"',V,'"'],P).

:-dynamic(xml_indent/2).
:-dynamic(xml_indent_current/1).

xml_indent_clear(Mark) :-
	retractall(xml_indent(Mark,_)),
	asserta(xml_indent(Mark,'')).
xml_indent_more(Mark) :-
	xml_indent(Mark,''),
	retractall(xml_indent(Mark,_)),	
	asserta(xml_indent(Mark,'    ')).
xml_indent_more(Mark) :-
	xml_indent(Mark,L),
	concat('    ',L,N),
	retractall(xml_indent(Mark,_)),
	asserta(xml_indent(Mark,N)).
xml_indent_less(Mark) :-
	xml_indent(Mark,'').
xml_indent_less(Mark) :-
	xml_indent(Mark,L),
	concat('    ',N,L),
	retractall(xml_indent(Mark,_)),
	asserta(xml_indent(Mark,N)).
	
xml_indent_mark_set(M) :-
	retractall(xml_indent_current(_)),
	asserta(xml_indent_current(M)).
